package labyrinthe;

import java.util.ArrayList;
import java.util.List;

import javafx.util.Pair;
import modeles.Arme;
import modeles.Armure;


public class Salle {
	private Pair<Integer,Integer> coordonnees;
	private boolean sortie;
	private List<Integer> listePorte= new ArrayList<Integer>();
	private List<Integer> listeEnnemie= new ArrayList<Integer>(); //indice de monstre
	private boolean estMarche;

	public Salle(int x, int y, boolean out,boolean marche) {
		this.listeEnnemie=new ArrayList<Integer>();
		this.coordonnees=new Pair<Integer,Integer>(x,y);
		this.sortie=out;
		this.estMarche=marche;
	}
	
	public Salle(int positionX, int positionY, boolean sortie, List<Integer> listeEnnemie) {
		this.coordonnees=new Pair<Integer,Integer>(positionX,positionY);
		this.sortie = sortie;
		this.listeEnnemie = listeEnnemie;
		this.estMarche=false;
	}
	
	public boolean isEstMarche() {
		return estMarche;
	}

	public Pair<Integer,Integer> getCoordonnes() {
		return this.coordonnees;
	}

	public boolean estSortie() {
		return sortie;
	}
	
	public List<Integer> getListePorte() {
		return this.listePorte;
	}

	
	public List<Integer> getListeEnnemie() {
		return listeEnnemie;
	}

	public boolean equals(Object o) {
		return (this.coordonnees.getKey()==((Salle)o).getCoordonnes().getKey() && this.coordonnees.getValue() ==((Salle)o).getCoordonnes().getValue());
	}
	

	public void cle(Labyrinthe lab) {
			for (int i : listePorte ) lab.listePorte.get(i).ouverture();
	}

	public boolean estVide() {
		return (listeEnnemie.size()==0);
	}
	
	 public Salle findNextSalle(Pair<Integer,Integer> coordonnes,Labyrinthe lab) {
		 for (int porte : listePorte) {
			 if (lab.listePorte.get(porte).prochainSaut(this).coordonnees.equals(coordonnes)) return lab.listePorte.get(porte).prochainSaut(this);
		 }
		 return null;
	 }
	 
	 public String creerObjetsAVendre(Labyrinthe lab) {
		 	if (!estMarche)return "";
		 	String listeSarme="";
			String listeSarmure="";
			String listeobjet="";
			int i = 0;
			int j =0;
			
			for (Arme arme : lab.listeArme) listeSarme +=i++ +") "+ arme.getNom() + " au prix de : " + arme.getPrix()+" (dgat bonus : "+arme.getpArme()+" /durabilit : "+arme.getUsure()+" )\n";
			
			for (Armure armure : lab.listeArmure) listeSarmure +=j++ +") "+ armure.getNom()+ " au prix de : " + armure.getPrix()+" (protection : "+armure.getpArmure()+" /durabilit : "+armure.getUsure()+") \n";
			
			listeobjet = "Armes :\n" + listeSarme + "\nArmures :\n" + listeSarmure;
			
			return listeobjet;
		}

	@Override
	public String toString() {
		return "Salle [coordonnees=" + coordonnees + ", sortie=" + sortie + ", listePorte=" + listePorte
				+ ", listeEnnemie=" + listeEnnemie + ", estMarche=" + estMarche + "]";
	}
}
